/*
 * ContourAnalyzer.h
 *
 *  Created on: Apr 22, 2018
 *      Author: Yunyang
 */

#ifndef RECTANGLE_DETECTION_CONTOURANALYZER_H_
#define RECTANGLE_DETECTION_CONTOURANALYZER_H_
#include <string>
#include <opencv2/opencv.hpp>
#include "../../UI.h"

class ContourAnalyzer {
	UI *ui;
	std::vector<std::vector<cv::Point>> contours;
	std::vector<std::vector<cv::Point>> prunedContours;
	std::vector<cv::Rect> bounds;

public:
	int binLowerThresh = 123;
	int binUpperThresh = 255;

	ContourAnalyzer(UI* ui);

	virtual ~ContourAnalyzer();

	cv::Scalar selectColor { 0, 255, 0 };
	cv::Scalar fontColor { 0, 0, 255 };

	int analyze();
	void drawShapePositions(cv::Mat &frame);
	std::string contourToString(std::vector<cv::Point>);
	void convertContoursToBounds();

	std::vector<cv::Rect> getBounds() const;
};

#endif /* RECTANGLE_DETECTION_CONTOURANALYZER_H_ */
