/*
 * UI.h
 *
 *  Created on: May 5, 2018
 *      Author: Yunyang
 */

#ifndef UI_H_
#define UI_H_
#include <opencv2/opencv.hpp>
#include "UIListener.hpp"

class UI {
	bool debug = false, showSlider = false;
	unsigned debugFrame = 0;
	int *lastKey;
	unsigned state = 0;
	std::vector<cv::Mat> frames = {cv::Mat()};
public:
	std::vector<UIListener *> UIListeners;
	UI(int *lastKey);
	void render();
	void nextDebugFrame();
	cv::Mat* nextFrame();
	cv::Mat* currentFrame(int offset);

	void setOriginalFrame(cv::Mat frame);

	virtual ~UI();
};

#endif /* UI_H_ */
